/*
 * the oa project.
 *
 * Sed - december 1999
 *
 * This is public domain.
 *
 * the event file
 */

#include "event.h"

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

int wait_event(int screen_descriptor, int sound_descriptor, int is_sound_ok)
{
  int res=0;
  fd_set r, w;
  int max;

  FD_ZERO(&r);
  FD_ZERO(&w);

  FD_SET(screen_descriptor, &r);
  max = screen_descriptor;

  if (is_sound_ok) {
#ifndef ALSA
    FD_SET(sound_descriptor, &w);
#else
    /* ALSA, you suck my energy... */
    FD_SET(sound_descriptor, &r);
#endif
    if (sound_descriptor > max) max = sound_descriptor;
  }

  if (select(max+1, &r, &w, (fd_set *)0, (struct timeval *)0)==-1)
    return 0;

  if (FD_ISSET(screen_descriptor, &r))
    res|=SCREEN_EVENT;

#ifndef ALSA
  if (is_sound_ok && FD_ISSET(sound_descriptor, &w))
#else
    /* ALSA, you suck my energy again and again... */
  if (is_sound_ok && FD_ISSET(sound_descriptor, &r))
#endif
    res|=SOUND_EVENT;

  return res;
}
