/* the oa project.
 *
 * Sed - december 1999
 *
 * This is public domain.
 *
 * the wav stuff file
 */

#include "wav.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

static int inited=0;

static int dumpfd;
static char dumpfn[24];	/* it's enough, because file name can't be more than 23 bytes */

/* return 0 if error 1 if not */
/* we get in entry the file name (without the .wav extension) */
int init_dump_wav(char *n)
{
  struct stat s;

  if (!strlen(n))
    return 0;

  strcpy(dumpfn, n);
  strcpy(dumpfn+strlen(dumpfn), ".wav");

  /* does file already exist ? */
  /* if not, create it, put the header with a length=0 */
  if (stat(dumpfn, &s)==-1) {
    short dum16;
    unsigned long dum;

    if ((dumpfd=open(dumpfn, O_WRONLY|O_CREAT|O_TRUNC, 0644))==-1)
      return 0;

    /* write "RIFF" */
    if (write(dumpfd, "RIFF", 4)!=4)
      goto error;
    /* write "waveform chunk size" (don't know what it is, directly taken from sox) */
    dum=0/*samp->sample_length*/+8+16+12;      /* mikmod adds only 32, what's correct ??? */
    if (write(dumpfd, &dum, 4)!=4)
      goto error;
    /* write "WAVE" and "fmt " */
    if (write(dumpfd, "WAVEfmt ", 8)!=8)
      goto error;
    /* write "fmt chunk size" (directly from sox once again) */
    dum=16;
    if (write(dumpfd, &dum, 4)!=4)
      goto error;
    /* write format tag (1) (sox again) (all is sox anyway) */
    dum16=1;
    if (write(dumpfd, &dum16, 2)!=2)
      goto error;
    /* number of channels (1) */
    if (write(dumpfd, &dum16, 2)!=2)
      goto error;
    /* the rate */
    dum=44100;
    if (write(dumpfd, &dum, 4)!=4)
      goto error;
    /* average bytes/sec */
    dum=44100*2;
    if (write(dumpfd, &dum, 4)!=4)
      goto error;
    /* block align */
    dum16=(16+7)/8;
    if (write(dumpfd, &dum16, 2)!=2)
      goto error;
    /* bits per sample */
    dum16=16;
    if (write(dumpfd, &dum16, 2)!=2)
      goto error;
    /* write "data" */
    if (write(dumpfd, "data", 4)!=4)
      goto error;
    /* sample length (0 for now) */
    dum=0;
    if (write(dumpfd, &dum, 4)!=4)
      goto error;
    /* now write data (if 8b, must translate in unsigned then back in signed (long but no malloc) */
    /* nothing to write for now */

    if (close(dumpfd)==-1) {
      unlink(dumpfn);
      return 0;
    }
  }

  /* note that if file already exist, no check is made to see if it is ok, we assume the wav header as
   * being ok
   */
  if ((dumpfd=open(dumpfn, O_WRONLY, 0644))==-1)
    return 0;
  if (lseek(dumpfd, 0, SEEK_END)==-1) {
    close(dumpfd);
    return 0;
  }

  inited=1;
  return 1;

error:
  close(dumpfd);
  unlink(dumpfn);
  return 0;
}

/* return 0 if error 1 if not */
int close_dump_wav(void)
{
  unsigned long s;

  if (!inited)
    return 0;

  inited=0;

  /* let's get the file size */
  s=lseek(dumpfd, 0, SEEK_END);
  if (s==-1) {
    close(dumpfd);
    return 0;
  }

  /* and update the wav header */
  s-=8;
  /* first place to update */
  /* no check, it will work, it is just a write over */
  lseek(dumpfd, 4, SEEK_SET);
  if (write(dumpfd, &s, 4)) /* nothing, just shut up gcc */;
  /* second place */
  s-=36;
  lseek(dumpfd, 40, SEEK_SET);
  if (write(dumpfd, &s, 4)) /* nothing, just shut up gcc */;

  if (close(dumpfd)==-1) {
    unlink(dumpfn);
    return 0;
  }

  return 1;
}

/* return 0 if error 1 if not */
/* The file is already opened, we simply put the buffer.
 */
int dump_wav(char *b, int s)
{
  if (!inited)
    return 0;

  if (write(dumpfd, b, s)!=s) {
    close_dump_wav();
    return 0;
  }

  return 1;
}
